![genie banner](https://raw.githubusercontent.com/Sage-Bionetworks/Genie/master/genie_banner.png)

# AACR Project GENIE

[![PyPi](https://img.shields.io/pypi/v/aacrgenie.svg?style=for-the-badge&label=PyPi&logo=PyPi)](https://pypi.org/project/aacrgenie)
[![Docker Automated](https://img.shields.io/docker/automated/sagebionetworks/genie.svg?style=for-the-badge&logo=docker)](https://hub.docker.com/r/sagebionetworks/genie)
[![GitHub CI](https://img.shields.io/github/actions/workflow/status/Sage-Bionetworks/Genie/ci.yml?branch=develop&style=for-the-badge&logo=github)](https://github.com/Sage-Bionetworks/Genie)


## Introduction

This repository documents code used to gather, QC, standardize, and analyze data uploaded by institutes participating in AACR's Project GENIE (Genomics, Evidence, Neoplasia, Information, Exchange). 

## Dependencies

This package contains both R, Python and cli tools.  These are tools or packages you will need, to be able to reproduce these results:
- Python >3.7 or <3.10
    - `pip install -r requirements.txt`
- [bedtools](https://bedtools.readthedocs.io/en/latest/content/installation.html)
- R 4.2.2
    - `renv::install()`
    - Follow instructions [here](https://r-docs.synapse.org/#note-for-windows-and-mac-users) to install synapser
- [Java > 8](https://www.java.com/en/download/)
    - For mac users, it seems to work better to run `brew install java`
- [wget](https://www.gnu.org/software/wget/)
    - For mac users, have to run `brew install wget`

## File Validator

One of the features of the `aacrgenie` package is that is provides a local validation tool that GENIE data contributors and install and use to validate their files locally prior to uploading to Synapse.

```
pip install aacrgenie
genie -v
```

This will install all the necessary components for you to run the validator locally on all of your files, including the Synapse client.  Please view the help to see how to run to validator.

```
genie validate -h
genie validate data_clinical_supp_SAGE.txt SAGE
```



## Contributing

Please view [contributing guide](CONTRIBUTING.md) to learn how to contribute to the GENIE package.


# Sage Bionetworks Only

## Developing locally

These are instructions on how you would develop and test the pipeline locally.

1. Make sure you have read through the [GENIE Onboarding Docs](https://sagebionetworks.jira.com/wiki/spaces/APGD/pages/2163344270/Onboarding) and have access to all of the required repositories, resources and synapse projects for Main GENIE.
1. Be sure you are invited to the Synapse GENIE Admin team.
1. Make sure you are a Synapse certified user: [Certified User - Synapse User Account Types](https://help.synapse.org/docs/Synapse-User-Account-Types.2007072795.html#SynapseUserAccountTypes-CertifiedUser)
1. Clone this repo and install the package locally.

    ```
    pip install -e .
    pip install -r requirements.txt
    pip install -r requirements-dev.txt
    ```

1. Run the different pipelines on the test project.  The `--project_id syn7208886` points to the test project.

    1. Validate all the files.

        ```
        python bin/input_to_database.py main --project_id syn7208886 --onlyValidate
        ```

    1. Process all the files aside from the mutation (maf, vcf) files.  The mutation processing was split because it takes at least 2 days to process all the production mutation data.  Ideally, there is a parameter to exclude or include file types to process/validate, but that is not implemented.

        ```
        python bin/input_to_database.py main --project_id syn7208886 --deleteOld
        ```

    1. Process the mutation data.  Be sure to clone this repo: https://github.com/Sage-Bionetworks/annotation-tools.  This repo houses the code that re-annotates the mutation data with genome nexus.  The `--createNewMafDatabase` will create a new mutation tables in the test project.  This flag is necessary for production data for two main reasons:
        * During processing of mutation data, the data is appended to the data, so without creating an empty table, there will be duplicated data uploaded.
        * By design, Synapse Tables were meant to be appended to.  When a Synapse Tables is updated, it takes time to index the table and return results. This can cause problems for the pipeline when trying to query the mutation table.  It is actually faster to create an entire new table than updating or deleting all rows and appending new rows when dealing with millions of rows.

        ```
        python bin/input_to_database.py mutation --project_id syn7208886 --deleteOld --genie_annotation_pkg ../annotation-tools --createNewMafDatabase
        ```

    1. Create a consortium release.  Be sure to add the `--test` parameter. Be sure to clone the cbioportal repo: https://github.com/cBioPortal/cbioportal

        ```
        python bin/database_to_staging.py Jan-2017 ../cbioportal TEST --test
        ```

    1. Create a public release.  Be sure to add the `--test` parameter.  Be sure to clone the cbioportal repo: https://github.com/cBioPortal/cbioportal

        ```
        python bin/consortium_to_public.py Jan-2017 ../cbioportal TEST --test
        ```

## Production

The production pipeline is run on Nextflow Tower and the Nextflow workflow is captured in [nf-genie](https://github.com/Sage-Bionetworks-Workflows/nf-genie).  It is wise to create an ec2 via the Sage Bionetworks service catalog to work with the production data, because there is limited PHI in GENIE.

# Update mutation in cis table
uploadToTable <- function(tbl, databaseSynId, subSetSamples, centerMappingDf) {
  # Old samples
  # filterCenters = centerMappingDf$center[centerMappingDf$mutationInCisFilter == TRUE]
  keepCenters = centerMappingDf$center[centerMappingDf$mutationInCisFilter == "OFF"]
  flagCenters = centerMappingDf$center[centerMappingDf$mutationInCisFilter == "FLAG"]
  query_string = sprintf("SELECT * FROM %s where Tumor_Sample_Barcode in ('%s')",
                         databaseSynId,
                         subSetSamples)
  annotated <- synapser::synTableQuery(query_string)
  annotated_df <- synapser::as.data.frame(annotated)
  annotated_df$HGVSp_Short[is.na(annotated_df$HGVSp_Short)] <- ""
  samples = paste(annotated_df$Tumor_Sample_Barcode,
                  "Sp:", annotated_df$HGVSp_Short,
                  "str:", annotated_df$Start_Position,
                  "ref:", annotated_df$Reference_Allele,
                  "tumor:", annotated_df$Tumor_Seq_Allele2)
  # New samples
  #tbl$HGVSp_Short[is.na(tbl$HGVSp_Short)] <- ""
  #This has to be done because HGVSp_Short is a factor
  nodup_tbl <- tbl[!duplicated(tbl),]
  hgvsp = as.character(nodup_tbl$HGVSp_Short)
  hgvsp[is.na(hgvsp)] <- ""
  new_samples = paste(nodup_tbl$Tumor_Sample_Barcode,
                      "Sp:", hgvsp,
                      "str:", nodup_tbl$Start_Position,
                      "ref:", nodup_tbl$Reference_Allele,
                      "tumor:", nodup_tbl$Tumor_Seq_Allele2)
  #Any data that is not the current output but in the database will be changed to FIXED
  if (nrow(annotated_df) > 0 ) {
    # FLAG variants first
    if (any(annotated_df$Center %in% flagCenters)) {
      annotated_df$Flag[annotated_df$Center %in% flagCenters] = "FLAG"
    }
    if (any(annotated_df$Flag[!samples %in% new_samples] == "TOSS")) {
      annotated_df$Flag[!samples %in% new_samples][
        annotated_df$Flag[!samples %in% new_samples] == "TOSS"] = "FIXED"
    } 
    if (any(annotated_df$Center %in% keepCenters)) {
      annotated_df$Flag[annotated_df$Center %in% keepCenters] = "KEEP"
    }
    synapser::synStore(Table(databaseSynId, annotated_df))
  }
  
  #Append any new data
  new_rows = nodup_tbl[!new_samples %in% samples,]
  #Even when nodup_tbl is empty, it can be subsetted, causing one NA row to be uploaded.
  if (nrow(new_rows) > 0 && nrow(nodup_tbl) > 0) {
    #By default everything is labelled TOSS unless the default filter is FALSE
    #NOTE:  If a center is set from default filter TRUE -> FALSE then switches back,
    #       This center's mutationInCis KEEP data will have to be erased.
    #       And processing will have to be run again after mutationsInCis is run on this center
    #       Due to the centers mutationInCis input file.
    new_rows$Flag = "TOSS"
    new_rows$Flag[new_rows$Center %in% keepCenters] = "KEEP"
    new_rows$Flag[new_rows$Center %in% flagCenters] = "FLAG"
    tableToAppend <- synapser::Table(databaseSynId, new_rows)
    synapser::synStore(tableToAppend)
  }
}

# Flag variants to merge
flag_variants_to_merge <- function(genieMutData, genieClinData, samplesToRun, upload = TRUE) {
  
  genieMutData <- data.frame( lapply( genieMutData , factor ))
  # Create factors for clinical data
  
  SAMPLE_ID = genieClinData$SAMPLE_ID[genieClinData$SAMPLE_ID %in% samplesToRun]
  genieClinData = data.frame(SAMPLE_ID)
  genieClinData <- data.frame( lapply( genieClinData , factor ))
  # all inclusive list of samples should be from the clinical data file
  # therefore factor levels for Tumor_Sample_Barcode in the MAF should be set to that of SAMPLE_ID of clinical data table 
  # check that no samples are listed in the MAF that are not listed in the clinical data file
  # reversing the order of the inputs would tell you which samples are submitted that have no entries (no mutations) in the MAF
  if (length(setdiff(levels(genieMutData$Tumor_Sample_Barcode),
                     levels(genieClinData$SAMPLE_ID))) == 0) {
    genieMutData$Tumor_Sample_Barcode = factor(genieMutData$Tumor_Sample_Barcode,
                                               levels = levels(genieClinData$SAMPLE_ID))
  }
  
  # records with count data that preclude a VAF estimate - set VAF to 100% (1/1, alt/depth)
  # genieMutData$t_depth <-  as.numeric(genieMutData$t_depth) DONT DO THIS LINE...
  genieMutData$t_depth <-  as.numeric(levels(genieMutData$t_depth))[genieMutData$t_depth]
  noVAF.idx = which((genieMutData$t_depth == 0) | is.na(genieMutData$t_depth))
  genieMutData$t_alt_count_num = 
    as.numeric(levels(genieMutData$t_alt_count))[genieMutData$t_alt_count]
  #if (length(noVAF.idx) > 0) {
  genieMutData$t_alt_count_num[noVAF.idx] = 1
  genieMutData$t_depth[noVAF.idx] = 1
  #}
  genieMutData$Start_Position <- as.numeric(as.character(genieMutData$Start_Position))
  genieMutData$End_Position <- as.numeric(as.character(genieMutData$End_Position))
  genieMutData$Tumor_Seq_Allele2 <- as.character(genieMutData$Tumor_Seq_Allele2)
  #invalid class “VRanges” object: if 'alt' is 'NA', then 'altDepth' should be 'NA'
  genieMutData$t_alt_count_num[is.na(genieMutData$Tumor_Seq_Allele2)] <- NA
  
  # get VRanges for all variants called in the MAF
  mafVR = VRanges(seqnames = Rle(paste0("chr",genieMutData$Chromosome)),
                  ranges = IRanges(start = genieMutData$Start_Position,
                                   end = genieMutData$End_Position),
                  ref = genieMutData$Reference_Allele,
                  # alt = genieMutData$Tumor_Seq_Allele2,
                  altDepth = genieMutData$t_alt_count_num,
                  totalDepth = genieMutData$t_depth,
                  sampleNames = genieMutData$Tumor_Sample_Barcode)
  seqlevels(mafVR) = sort(seqlevels(mafVR))
  
  # precompute
  vaf = altDepth(mafVR)/totalDepth(mafVR)
  ord = order(mafVR)
  
  # start with empty table
  tbl = genieMutData[1, c("Center","Tumor_Sample_Barcode","Hugo_Symbol",
                          "HGVSp_Short","Variant_Classification","Chromosome",
                          "Start_Position","Reference_Allele","Tumor_Seq_Allele2",
                          "t_alt_count_num","t_depth")]
  tbl = tbl[-1,]
  
  # check for potential variants that may need to be evaluated for merge (cis/trans)
  genieMutData$Tumor_Sample_Barcode <- as.character(genieMutData$Tumor_Sample_Barcode)
  #genieClinData$SAMPLE_ID <- as.character(genieClinData$SAMPLE_ID)
  t = Sys.time()
  samplesRun = c()
  for (i in 1:length(samplesToRun)) {
    
    # get sample indices (in order from pre sort above)
    idx = ord[which(genieMutData$Tumor_Sample_Barcode[ord] == samplesToRun[i])]
    samplesRun = c(samplesRun, samplesToRun[i])
    # get length of idx
    l = length(idx)
    
    # if sample has more than one variant
    if (l > 1) {
      # get differences in BPs of variant sites
      dBP = distance(mafVR[idx[1:(l - 1)]], mafVR[idx[2:(l)]])
      # get difference in VAFs of variants
      dVAF = abs(diff(vaf[idx]))

      # potential matches - criteria of difference in BPs between of > 0 & < 6 bps difference, < 5% VAF difference
      pm = which((dBP > 0) & (dBP < 6) & (dVAF < .05))
      for (m in pm) {
        # calc difference in codon number
        codonDiff = abs(diff(as.numeric(sapply(strsplit(as.character(genieMutData$Protein_position[c(idx[m],idx[m + 1])]),split = "/"),"[",1))))
        if (is.na(codonDiff) | (codonDiff == 1)) {
          tbl = rbind(tbl,genieMutData[c(idx[m],idx[m + 1]),
                                       c("Center","Tumor_Sample_Barcode","Hugo_Symbol",
                                         "HGVSp_Short","Variant_Classification","Chromosome",
                                         "Start_Position","Reference_Allele",
                                         "Tumor_Seq_Allele2","t_alt_count_num","t_depth")])
        }
      }
    }
    if (upload) {
      # time ticker per 100 cases
      if ((i %% 100) == 0) {
        print(i)
        t[2] = Sys.time()
        print(t[2] - t[1])
        t[1] = t[2]
      }
      #HAve to keep track of how far it is in the chunk
      if (nrow(tbl) > tbl_size_limit || i == length(samplesToRun)) {
        uploadToTable(tbl, mutationsInCisSynId, paste(samplesRun, collapse = "','"), centerMappingDf)
        tbl = genieMutData[1,c("Center","Tumor_Sample_Barcode","Hugo_Symbol",
                               "HGVSp_Short","Variant_Classification","Chromosome",
                               "Start_Position","Reference_Allele","Tumor_Seq_Allele2",
                               "t_alt_count_num","t_depth")]
        tbl = tbl[-1,]
        samplesRun = c()
      }
    } else {
      return(tbl)
    }
  }
}

get_working_dir <- function() {
  cmdArgs <- commandArgs(trailingOnly = FALSE)
  needle <- "--file="
  match <- grep(needle, cmdArgs)
  if (length(match) > 0) {
    # Rscript
    return(dirname(normalizePath(sub(needle, "", cmdArgs[match]))))
  } else {
    # 'source'd via R console
    return("./")
  }
}
working_dir = get_working_dir()
source(file.path(working_dir, "mergecheck_functions.R"))
library(testthat)
library(VariantAnnotation)
genieMutData = matrix(nrow = 2, ncol = 13)
colnames(genieMutData) = c("Chromosome", "Hugo_Symbol", "Start_Position", "End_Position", "Reference_Allele",
                           "Tumor_Seq_Allele2", "t_depth", 't_alt_count', "Tumor_Sample_Barcode", 
                           "Protein_position", "HGVSp_Short", "Variant_Classification", "Center")


genieMutData[,'Chromosome'] = c("1", "1")
genieMutData[,'Start_Position'] = c("1", "3")
genieMutData[,'End_Position'] = c("1", "3")
genieMutData[,'Reference_Allele'] = c("A", "C")
genieMutData[,'Tumor_Seq_Allele2'] = c("T", "G")
genieMutData[,'t_alt_count'] = c(1, 2)
genieMutData[,'t_depth'] = c(100, 100)
genieMutData[,'Tumor_Sample_Barcode'] = c("SAGE1", "SAGE1")
genieMutData[,'Protein_position'] =  c("3/4", "4/4")
genieMutData[,'Hugo_Symbol'] = c("ROS1", "ROS1")
genieMutData[,'Center'] = c("SAGE", "SAGE")

genieMutData = as.data.frame(genieMutData, stringsAsFactors = F)
genieClinData = data.frame(SAMPLE_ID = c("SAGE1"),
                           stringsAsFactors = F)

test_that("Mutations are flagged, same starts and ends", {
  tbl = flag_variants_to_merge(genieMutData, genieClinData, c("SAGE1"), upload=F)
  expected = genieMutData[, c("Center", "Tumor_Sample_Barcode", "Hugo_Symbol",
                              "Variant_Classification", "Chromosome", "Start_Position",
                              "Reference_Allele", "Tumor_Seq_Allele2","t_depth",
                              "HGVSp_Short")]
  expected$t_alt_count_num = c(1, 2)
  # Change everything to factors or else its difficult to validate is absurd
  # This is ok because we don't do anything with factors after the function is ran
  expected <- data.frame( lapply( expected , factor ))
  tbl <- data.frame( lapply( tbl , factor ))
  expect_equal(tbl, expected[,colnames(tbl)])
})

genieMutData$Start_Position[2] = "15"
genieMutData$End_Position[2] = "15"
test_that("Mutations are not flagged", {
  tbl = flag_variants_to_merge(genieMutData, genieClinData, c("SAGE1"), upload=F)
  expect_equal(nrow(tbl), 0)
  expect_equal(colnames(tbl), c("Center", "Tumor_Sample_Barcode", "Hugo_Symbol", "HGVSp_Short",
                                "Variant_Classification", "Chromosome", "Start_Position",
                                "Reference_Allele", "Tumor_Seq_Allele2", "t_alt_count_num", "t_depth"))
  
})

genieMutData$Start_Position = c("1", "10")
genieMutData$End_Position = c("5", "12")
test_that("Mutations are flagged, different starts and ends", {
  tbl = flag_variants_to_merge(genieMutData, genieClinData, c("SAGE1"), upload=F)
  expected = genieMutData[, c("Center", "Tumor_Sample_Barcode", "Hugo_Symbol",
                              "Variant_Classification", "Chromosome", "Start_Position",
                              "Reference_Allele", "Tumor_Seq_Allele2","t_depth",
                              "HGVSp_Short")]
  expected$t_alt_count_num = c(1, 2)
  # Change everything to factors or else its difficult to validate is absurd
  # This is ok because we don't do anything with factors after the function is ran
  expected <- data.frame( lapply( expected , factor ))
  tbl <- data.frame( lapply( tbl , factor ))
  expect_equal(tbl, expected[,colnames(tbl)])
})


genieMutData$Start_Position = c("1", "10")
genieMutData$End_Position = c("5", "12")
test_that("Mutations not flagged, different starts and ends", {
  tbl = flag_variants_to_merge(genieMutData, genieClinData, c("SAGE1"), upload=F)
  expected = genieMutData[, c("Center", "Tumor_Sample_Barcode", "Hugo_Symbol",
                              "Variant_Classification", "Chromosome", "Start_Position",
                              "Reference_Allele", "Tumor_Seq_Allele2","t_depth",
                              "HGVSp_Short")]
  expected$t_alt_count_num = c(1, 2)
  # Change everything to factors or else its difficult to validate is absurd
  # This is ok because we don't do anything with factors after the function is ran
  expected <- data.frame( lapply( expected , factor ))
  tbl <- data.frame( lapply( tbl , factor ))
  expect_equal(tbl, expected[,colnames(tbl)])
})

library(argparse)
parser <- ArgumentParser()
parser$add_argument("filepath", help = "Filepath to write variants")
parser$add_argument("--testing", action = "store_true", help = "Use testing files")
parser$add_argument("--syn_user", help = "Synapse username")
parser$add_argument("--syn_pass", help = "Synapse password")
args <- parser$parse_args()
genie_user <- args$syn_user
genie_pass <- args$syn_pass
testing <- args$testing
filepath <- args$filepath


# libraries
library(synapser)
#pyExec("syn.table_query_timeout=50000")
library(VariantAnnotation)

# args = commandArgs(trailingOnly=TRUE)
# if (length(args) != 2) {
#   stop("Must supply a boolean value and a filepath to write variants not in bed")
# }
# SAGE login
tryCatch({
  synLogin()# set user and password
}, error = function(err) {
  #genieUser = Sys.getenv("GENIE_USER")
  #geniePass = Sys.getenv("GENIE_PASS")
  synLogin(genie_user, genie_pass)
})
#testing = as.logical(args[1])
if (testing) {
  databaseSynIdMappingId = 'syn11600968'
} else {
  databaseSynIdMappingId = 'syn10967259'
}
databaseSynIdMapping = synTableQuery(sprintf('select * from %s', databaseSynIdMappingId),
                                     includeRowIdAndRowVersion = F)
databaseSynIdMappingDf = synapser::as.data.frame(databaseSynIdMapping)
patientSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "patient"]
sampleSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "sample"]
bedSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "bed"]
mafSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "vcf2maf"]
assayInfoSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "assayinfo"]
centerMappingSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "centerMapping"]

centerMapping = synTableQuery(sprintf('select * from %s where release is true',
                                      centerMappingSynId),
                              includeRowIdAndRowVersion = F)
centerMappingDf = synapser::as.data.frame(centerMapping)
process_centers = paste(centerMappingDf$center, collapse="','")
# read aggregated clinical data from tables
patient = synTableQuery(sprintf("SELECT * FROM %s where CENTER in ('%s')",
                                patientSynId, process_centers),
                        includeRowIdAndRowVersion = F)
sample = synTableQuery(sprintf("SELECT * FROM %s where CENTER in ('%s')",
                               sampleSynId, process_centers),
                       includeRowIdAndRowVersion = F)

patientData = synapser::as.data.frame(patient)
sampleData = synapser::as.data.frame(sample)
sampleData$AGE_AT_SEQ_REPORT_NUMERICAL <- NULL
patientData$BIRTH_YEAR_NUMERICAL <- NULL
patientData$CENTER <- NULL
genieClinData <- merge.data.frame(patientData,
                                  sampleData,
                                  by = "PATIENT_ID")

#EXCLUDE PHS-TRISEQ-V1 SAMPLES
# genieClinData <- genieClinData[genieClinData$SEQ_ASSAY_ID != "PHS-TRISEQ-V1",]

# read aggregated BED file data
genieBed = synTableQuery(sprintf("SELECT * FROM %s where CENTER in ('%s')",
                                 bedSynId, process_centers),
                         includeRowIdAndRowVersion = F)
genieBedData = synapser::as.data.frame(genieBed)

#Pad the bed file with the assay information
assayInfo = synTableQuery(sprintf("SELECT * FROM %s where CENTER in ('%s')",
                                  assayInfoSynId, process_centers),
                          includeRowIdAndRowVersion = F)
assayInfoData = synapser::as.data.frame(assayInfo)
for (seq_assay in unique(genieBedData$SEQ_ASSAY_ID)) {
  if (any(assayInfoData$SEQ_ASSAY_ID == seq_assay)) {
    genepadding = assayInfoData$gene_padding[assayInfoData$SEQ_ASSAY_ID == seq_assay]
  } else {
    genepadding = 10
  }
  starts = genieBedData$Start_Position[genieBedData$SEQ_ASSAY_ID == seq_assay]
  ends = genieBedData$End_Position[genieBedData$SEQ_ASSAY_ID == seq_assay]
  genieBedData$Start_Position[genieBedData$SEQ_ASSAY_ID == seq_assay] = starts - genepadding
  genieBedData$End_Position[genieBedData$SEQ_ASSAY_ID == seq_assay] = ends + genepadding
}
# read aggregated MAF file
# FILTERED OUT COMMON VARIANTS HERE
#genieMut = synTableQuery(sprintf('SELECT * FROM %s where FILTER <> "common_variant"', mafSynId))
genieMut = synTableQuery(sprintf("SELECT * FROM %s where Center in ('%s') and Annotation_Status = 'SUCCESS'",
                                 mafSynId, process_centers))
genieMutData = synapser::as.data.frame(genieMut)
#Only use samples that exist in the clinical sample data pool
genieMutData <- genieMutData[genieMutData$Tumor_Sample_Barcode %in% genieClinData$SAMPLE_ID,]
print(nrow(genieMutData))


originalCols = colnames(genieMutData)
# records with count data that preclude a VAF estimate - set VAF to 100% (1/1, alt/depth)    genieMutData$t_depth <-  as.numeric(genieMutData$t_depth)
genieMutData$t_depth <-  as.numeric(genieMutData$t_depth)
noVAF.idx = which((genieMutData$t_depth == 0) | is.na(genieMutData$t_depth))
#keeps the order if factors exist
#genieMutData$t_alt_count_num = as.numeric(levels(genieMutData$t_alt_count))[genieMutData$t_alt_count]
genieMutData$t_alt_count_num = as.numeric(genieMutData$t_alt_count)
genieMutData$t_alt_count_num[noVAF.idx] = 1
genieMutData$t_depth_new = genieMutData$t_depth
genieMutData$t_depth_new[noVAF.idx] = 1

#genieMutData$t_depth_new[is.na(genieMutData$t_alt_count_num)] = 1
#genieMutData$t_alt_count_num[is.na(genieMutData$t_alt_count_num)] = 1
# get VRanges for all variants called in the MAF
genieMutData$t_alt_count_num[is.na(genieMutData$Tumor_Seq_Allele2)] = NA

mafVR = VRanges(seqnames = Rle(paste0("chr",genieMutData$Chromosome)),
                ranges = IRanges(start = genieMutData$Start_Position,
                                 end = genieMutData$End_Position),
                ref = genieMutData$Reference_Allele,
                # alt = genieMutData$Tumor_Seq_Allele2,
                altDepth = genieMutData$t_alt_count_num,
                # totalDepth = genieMutData$t_depth_new,
                sampleNames = genieMutData$Tumor_Sample_Barcode)
seqlevels(mafVR) = sort(seqlevels(mafVR))

# get GRanges for each bed
bedGR = split(genieBedData, factor(genieBedData$SEQ_ASSAY_ID))
bedGR = lapply(bedGR, function(x) {
  GR = GRanges(seqnames = Rle(paste0("chr",x$Chromosome)),
               ranges = IRanges(start = x$Start_Position, end = x$End_Position))
  seqlevels(GR) = sort(seqlevels(GR))
  return(GR)
})

# all inclusive list of samples should be from the clinical data file
# therefore factor levels for Tumor_Sample_Barcode in the MAF should be set to that of SAMPLE_ID of clinical data table
# check that no samples are listed in the MAF that are not listed in the clinical data file
# reversing the order of the inputs would tell you which samples are submitted that have no entries (no mutations) in the MAF
#if (length(setdiff(levels(genieMutData$Tumor_Sample_Barcode),levels(genieClinData$SAMPLE_ID)))==0) {
#  genieMutData$Tumor_Sample_Barcode = factor(genieMutData$Tumor_Sample_Barcode, levels=levels(genieClinData$SAMPLE_ID))
#}

# add factor to MAF and set to FALSE, forcing the variant to bed match for TRUE below to clear filter
oldInBed = as.logical(genieMutData$inBED)
genieMutData$inBED = FALSE
# collect some stats in panStats and set inBED to TRUE if variant is in corresponding BED
seq_assays = unique(genieClinData$SEQ_ASSAY_ID[!is.na(genieClinData$SEQ_ASSAY_ID)])
panStats = data.frame()
for (panelName in seq_assays) {
  print(panelName)
  samples.idx = which(genieClinData$SEQ_ASSAY_ID == panelName)
  panStats[panelName,"samples"] = length(samples.idx)
  samples.idx = which(genieMutData$Tumor_Sample_Barcode %in% genieClinData$SAMPLE_ID[samples.idx])
  panStats[panelName,"samples with calls"] = length(unique(genieMutData$Tumor_Sample_Barcode[samples.idx]))
  panStats[panelName,"variants calls"] = length(samples.idx)
  panStats[panelName,"unique variants calls"] = length(unique(mafVR[samples.idx]))
  if (length(samples.idx) > 0 && !is.null(bedGR[[panelName]])) {
    genieMutData$inBED[samples.idx] = mafVR[samples.idx] %over% bedGR[[panelName]]
  }
  panStats[panelName,"variants called out of BED"] = length(samples.idx[!genieMutData$inBED[samples.idx]])
  panStats[panelName,"unique variants called out of BED"] = length(unique(mafVR[samples.idx[!genieMutData$inBED[samples.idx]]]))
}
genieMutData$t_depth_new <- NULL
genieMutData$t_alt_count_num <- NULL
# Commented out below because of PFLM-4975
#Compare old inBED with new inBED column
#If there are differences, update only the diffs
# updateMutData = genieMutData[genieMutData$inBED != oldInBed,]
# if (nrow(updateMutData) > 0) {
#   #write.csv(updateMutData[c("ROW_ID","ROW_VERSION","inBED")],"update_inbed.csv",row.names = F)
#   #Need to chunk the upload

#   #it is an amazon problem, where amazon kills the connection while reading the csv from s3.
#   chunk = 100000
#   rows = 0
#   while (rows*chunk < nrow(updateMutData)) {
#     if ((rows + 1)* chunk > nrow(updateMutData)) {
#       to_update = updateMutData[((rows*chunk)+1):nrow(updateMutData),c("ROW_ID","ROW_VERSION","inBED")]
#     } else{
#       to_update = updateMutData[((rows*chunk)+1):((rows+1)*chunk),c("ROW_ID","ROW_VERSION","inBED")]
#     }
#     synStore(Table(mafSynId, to_update))
#     rows = rows+1
#   }
#   #synStore(Table(mafSynId, updateMutData[c("ROW_ID","ROW_VERSION","inBED")]))
#   #synStore(Table(mafSynId, "update_inbed.csv"))
# }
updateMutData = genieMutData[genieMutData$inBED == FALSE,
                             c('Chromosome', 'Start_Position', 'End_Position',
                               'Reference_Allele', 'Tumor_Seq_Allele2', 'Tumor_Sample_Barcode', 'Center')]
write.csv(updateMutData,filepath,row.names = F)

# Do not use scientific notation
options(scipen=999)
library(argparse)
parser <- ArgumentParser()
parser$add_argument("--testing",
                    action = "store_true",
                    help = "Use testing files")
parser$add_argument("--syn_user",
                    help = "Synapse username")
parser$add_argument("--syn_pass",
                    help = "Synapse password")
args <- parser$parse_args()
genie_user <- args$syn_user
genie_pass <- args$syn_pass
testing <- args$testing

library(synapser)
library(VariantAnnotation)

get_working_dir <- function() {
  cmdArgs <- commandArgs(trailingOnly = FALSE)
  needle <- "--file="
  match <- grep(needle, cmdArgs)
  if (length(match) > 0) {
    # Rscript
    return(dirname(normalizePath(sub(needle, "", cmdArgs[match]))))
  } else {
    # 'source'd via R console
    return("./")
  }
}
working_dir = get_working_dir()
source(file.path(working_dir, "mergecheck_functions.R"))
# Run quick unit test to make sure that the function hasn't be changed
source(file.path(working_dir, "test_flag_variants.R"))

# login to synapse
tryCatch({
  synLogin()
}, error = function(err) {
  #genieUser = Sys.getenv("GENIE_USER")
  #geniePass = Sys.getenv("GENIE_PASS")
  synLogin(genie_user, genie_pass)
})

# limits
variant_limit = 100000
tbl_size_limit = 500

#testing = as.logical(args[1])
if (testing) {
  databaseSynIdMappingId = 'syn11600968'
} else {
  databaseSynIdMappingId = 'syn10967259'
}
databaseSynIdMapping = synTableQuery(sprintf('select * from %s', databaseSynIdMappingId),
                                     includeRowIdAndRowVersion = F)
databaseSynIdMappingDf = synapser::as.data.frame(databaseSynIdMapping)
sampleSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "sample"]
mutationsInCisSynId =
  databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "mutationsInCis"]
mafSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "vcf2maf"]

centersTable = synTableQuery(sprintf('select distinct CENTER from %s', sampleSynId),
                             includeRowIdAndRowVersion = F)
centers = synapser::as.data.frame(centersTable)
centers = centers$CENTER

centerMappingSynId = databaseSynIdMappingDf$Id[databaseSynIdMappingDf$Database == "centerMapping"]
centerMapping = synTableQuery(sprintf('select * from %s where release is true',
                                      centerMappingSynId),
                              includeRowIdAndRowVersion = F)
centerMappingDf = synapser::as.data.frame(centerMapping)
centerMappingDf$mutationInCisFilter = as.character(centerMappingDf$mutationInCisFilter)
# Have this here for now until the annotations are changed in the center mapping folder
centerMappingDf$mutationInCisFilter[centerMappingDf$mutationInCisFilter == "TRUE"] = "ON"
centerMappingDf$mutationInCisFilter[centerMappingDf$mutationInCisFilter == "FALSE"] = "OFF"

# ON - Filter is on: TOSS SAMPLES
# OFF - Filter is off: KEEP SAMPLES
# FLAG - Filter is on, but don't toss samples: FLAG BUT KEEP SAMPLES

for (center in centers) {
  print(center)
  # read aggregated clinical data
  clin_query_string = sprintf("select SAMPLE_ID from %s where CENTER = '%s'",
                              sampleSynId, center)
  genieClinTable = synTableQuery(clin_query_string, includeRowIdAndRowVersion = F)
  genieClinData = synapser::as.data.frame(genieClinTable)
  maf_query_string = sprintf("select Tumor_Sample_Barcode, count(Tumor_Sample_Barcode) from %s where Center = '%s' group by Tumor_Sample_Barcode",
                             mafSynId, center)
  mafSampleCountTable = synTableQuery(maf_query_string, includeRowIdAndRowVersion = F)
  mafSampleCount = synapser::as.data.frame(mafSampleCountTable)
  mafSampleCount =
    mafSampleCount[mafSampleCount$Tumor_Sample_Barcode %in% genieClinData$SAMPLE_ID,]
  total = 0
  splitBySamples = c()
  samplesToQuery = c()
  for (sample in mafSampleCount$Tumor_Sample_Barcode) {
    total = total + mafSampleCount[mafSampleCount$Tumor_Sample_Barcode == sample, "COUNT(Tumor_Sample_Barcode)"]
    samplesToQuery = c(sample,samplesToQuery)
    if (total > variant_limit || sample == mafSampleCount$Tumor_Sample_Barcode[nrow(mafSampleCount)]) {
      splitBySamples = c(splitBySamples, paste(samplesToQuery,collapse = "','"))
      total = 0
      samplesToQuery = c()
    }
  }
  for (querySamples in splitBySamples) {
    samplesToRun = unlist(strsplit(querySamples, "','"))
    # read aggregated MAF file
    genieMutTable = synTableQuery(sprintf("SELECT Center,Tumor_Sample_Barcode,Hugo_Symbol,HGVSp_Short,Variant_Classification,Chromosome,Start_Position,Reference_Allele,Tumor_Seq_Allele2,t_depth,t_alt_count,End_Position,Protein_position FROM %s where Tumor_Sample_Barcode in ('%s') and inBED is true and Annotation_Status = 'SUCCESS'",
                                          mafSynId, querySamples),
                                  includeRowIdAndRowVersion = F)
    #genieMutTable = synTableQuery(sprintf("SELECT Center,Tumor_Sample_Barcode,Hugo_Symbol,HGVSp_Short,Variant_Classification,Chromosome,Start_Position,Reference_Allele,Tumor_Seq_Allele2,t_depth,t_alt_count,End_Position,Protein_position FROM %s where Tumor_Sample_Barcode in ('%s')", mafSynId, querySamples),includeRowIdAndRowVersion=F)
    
    genieMutData = synapser::as.data.frame(genieMutTable)
    flag_variants_to_merge(genieMutData, genieClinData, samplesToRun, upload = TRUE)
    #write.csv(rbind(annotated_df[is.na(annotated_df$Flag),],new_rows), "Missing_variant_annotation.csv", row.names=F)
  }#FOR LOOP END FOR QUERY SAMPLES
}

source("renv/activate.R")
renv::restore()
library(synapser)
library(dplyr)
library(argparse)
library(UpSetR)
library(rmarkdown)
library(testthat)
library(VariantAnnotation)
library(xtable)
library(ggpubr)

#suppressPackageStartupMessages(library(synapserutils))
suppressPackageStartupMessages(library(argparse))
parser <- ArgumentParser()
parser$add_argument("release",
                    help = "Release version (ie. 5.3-consortium)")
parser$add_argument("--template_path",
                    help = "Path to dashboardTemplate.Rmd",
                    default="dashboardTemplate.Rmd")
parser$add_argument("--staging",
                    action = "store_true",
                    help = "Use staging files")
parser$add_argument("--testing",
                    action = "store_true",
                    help = "Use testing files")
parser$add_argument("--syn_user",
                    help = "Synapse username")
parser$add_argument("--syn_pass",
                    help = "Synapse password")

args <- parser$parse_args()
genie_user <- args$syn_user
genie_pass <- args$syn_pass
release <- args$release
template_path <- args$template_path
suppressPackageStartupMessages(library(synapser))
suppressPackageStartupMessages(library(rmarkdown))

tryCatch({
  synLogin()
}, error = function(err) {
  synLogin(genie_user, genie_pass)
})

if (args$staging) {
 database_synid_mappingid = 'syn12094210'
} else if (args$testing) {
 database_synid_mappingid = 'syn11600968'
} else{
 database_synid_mappingid = 'syn10967259'
}

# For testing only
# database_synid_mappingid = 'syn10967259'
# genie_user=NULL
# genie_pass=NULL
# release = "9.3-consortium"
# template_path = "genie/dashboardTemplate.Rmd"
#


rmarkdown_path = sprintf('%s.Rmd', release)
file.copy(template_path, rmarkdown_path, overwrite = T)
rmarkdown::render(rmarkdown_path,
                  params = list("genieUser" = genie_user,
                                "geniePass" = genie_pass,
                                "database_synid_mappingid" = database_synid_mappingid,
                                "release" = release))
# Obtain release folder
database_synid_mapping = synTableQuery(sprintf('select * from %s',
                                               database_synid_mappingid))
database_synid_mappingdf = as.data.frame(database_synid_mapping)
release_folder_fileview_synid = database_synid_mappingdf$Id[
  database_synid_mappingdf$Database == "releaseFolder"
]
release_folder = synTableQuery(sprintf("select id from %s where name = '%s'",
                                       release_folder_fileview_synid, release))
release_folder_synid = release_folder$asDataFrame()$id
#Store the html file.
html_path = sprintf('%s.html', release)
release_html_ent = synStore(File(html_path,
                                 parentId = release_folder_synid))
synStore(Wiki(markdown = sprintf("${preview?entityId=%s}",
                                 release_html_ent$properties$id),
              owner = release_folder_synid))

---
output: html_document
#  html_document:
#    toc: true
#    toc_depth: 3
params:
  genieUser:
    value: x
  geniePass:
    value: x
  database_synid_mappingid:
    value: x
  release:
    value: x
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = FALSE,
                      warning = FALSE,
                      fig.height = 8,
                      fig.width = 10)
```

---
title: '`r release`'
---

```{r intro}
suppressMessages(library(synapser))
tryCatch({
  foo = capture.output(synLogin())
}, error = function(err) {
  genieUser = params$genieUser
  geniePass = params$geniePass
  foo = capture.output(synLogin(genieUser, geniePass))
})

suppressMessages(library(ggplot2))
suppressMessages(library(UpSetR))
suppressMessages(library(RColorBrewer))
suppressMessages(library(jsonlite))
suppressMessages(library(knitr))

createCenterColumn <- function(clinicalDf) {        
  if (is.null(clinicalDf$CENTER)) {
    centers = unlist(
      lapply(strsplit(clinicalDf$PATIENT_ID, "-"), function(x) return(x[2])))
  } else {
    centers = clinicalDf$CENTER
  }
  return(centers)
}

getFileDf <- function(fileName, releaseFiles) {
  synId = unlist(lapply(releaseFiles, function(x) {
    if (x$name == fileName) {
      return(x$id)
    }
  }))
  if (length(synId) > 0) {
    ent = synGet(synId,followLink = T)
    df = read.csv(ent$path,sep = "\t", comment.char = "#", stringsAsFactors = F)
    return(df)
  } else {
    return(NULL)
  }
}

makePanelList = function(assay, bed) {
  return(unique(as.character(bed$Hugo_Symbol[bed$SEQ_PIPELINE_ID == assay])))
}

plotPanelOverlap <- function(bed, assays) {
  listInput = lapply(as.list(assays), function(x) { makePanelList(x, bed) })
  names(listInput) = assays
  upset(fromList(listInput),
        order.by = "freq",
        nsets = length(assays),
        nintersects = 30)
}

plotCenterXRace <- function(genieClinData) {
  t = as.data.frame.matrix(table(genieClinData$CENTER,genieClinData$PRIMARY_RACE))
  t = data.frame(n = rowSums(t),t)
  # kable(t)
  
  # kable(data.frame("Percent.Unknown" = (t[,"Unknown"]/rowSums(t[,colnames(t) != "n"]))*100), digits = 2)
  
  # reduce table to none "Unknown" data
  # t$n = t$n - t$Unknown
  # t = t[,!(colnames(t) == "Unknown")]
  # find sites with greater than 100 nono "Unknown" patients wrt race
  # k = which(t$n > 100)
  t = t[,c("n", "White", "Black", "Asian", "Native.American",
           "Other", "Unknown")]
  t[,colnames(t) != "n"] = t[,colnames(t) != "n"]/rowSums(t[,colnames(t) != "n"])
  # kable(t[k,],digits = 3)
  
  # Center vs Race BARCHARTS
  t$Center = rownames(t)
  l = c("White", "Black", "Asian", "Native.American",
        "Other", "Unknown")
  t = reshape(t,
              direction = "long",
              idvar = ("Center"),
              varying = l,
              v.names = "Percentage",
              times = l,
              drop = "n")
  colnames(t)[colnames(t) == "time"] = "Race"
  t$Race = factor(t$Race,l)
  plot(ggplot(t,aes(Race, Percentage, group = Center)) + 
         geom_bar(stat = "identity") +
         facet_wrap(~Center, ncol = 4) +
         ylim(0,1) +
         coord_flip() +
         ggtitle("Distribution of race across centers"))
}

plotCenterXEthnicity <- function(genieClinData) {
  t = as.data.frame.matrix(table(genieClinData$CENTER,genieClinData$ETHNICITY))
  # t = data.frame(n = rowSums(t),t)
  # kable(t)
  
  # kable(data.frame("Percent.Unknown" = (t[,"Unknown"]/rowSums(t[,colnames(t) != "n"]))*100), digits = 2)
  
  # t$n = t$n - t$Unknown
  # t = t[,!(colnames(t) == "Unknown")]
  # k = which(t$n > 100)
  t[,colnames(t) != "n"] = t[,colnames(t) != "n"]/rowSums(t[,colnames(t) != "n"])
  # kable(t[k,],digits = 3)
  
  # Center vs Ethnicity BARCHARTS
  t$Center = rownames(t)
  l = c("Non-Spanish/non-Hispanic", "Spanish/Hispanic", "Unknown")
  t = reshape(t,
              direction = "long",
              idvar = ("Center"),
              varying = l,
              v.names = "Percentage",
              times = l,
              drop = "n")
  colnames(t)[colnames(t) == "time"] = "Ethnicity"
  t$Ethnicity = factor(t$Ethnicity,l)
  plot(ggplot(t,aes(Ethnicity, Percentage, group = Center)) +
         geom_bar(stat = "identity") +
         facet_wrap(~Center,ncol = 4) +
         ylim(0,1) +
         coord_flip() +
         ggtitle("Distribution of ethnicity across centers"))
}

plotCenterXSex <- function(genieClinData) {
  t = as.data.frame.matrix(table(genieClinData$CENTER,genieClinData$SEX))
  t = data.frame(n = rowSums(t),t)
  kable(t)
  
  t[,colnames(t) != "n"] = t[,colnames(t) != "n"]/rowSums(t[,colnames(t) != "n"])
  kable(t,digits = 3)
  
  # Center vs Sex BARCHARTS
  t$Center = rownames(t)
  l = c("Female","Male")
  t = reshape(t,
              direction = "long",
              idvar = ("Center"),
              varying = l,
              v.names = "Percentage",
              times = l,
              drop = "n")
  colnames(t)[colnames(t) == "time"] = "Sex"
  t$Sex = factor(t$Sex, l)
  plot(ggplot(t,aes(Sex,Percentage,group = Center)) +
         geom_bar(stat = "identity") +
         facet_wrap(~Center,ncol = 4) +
         ylim(0,1) +
         coord_flip() +
         ggtitle("Distribution of sex across centers"))
}

plotCenterXAge <- function(genieClinData) {
  if (mean(as.numeric(genieClinData$AGE_AT_SEQ_REPORT),na.rm = T) < 100) {
    multiply = T
  } else {
    multiply = F
  } 
  genieClinData$age_days <- genieClinData$AGE_AT_SEQ_REPORT
  k = grep("^>",genieClinData$AGE_AT_SEQ_REPORT) # these are the >=90 group that get mapped to 90
  genieClinData$age_days[k] = 32872
  k = grep("^<",genieClinData$AGE_AT_SEQ_REPORT) # these are the <=18 group that get mapped to 18
  genieClinData$age_days[k] = 6573
  genieClinData$age_days = as.numeric(genieClinData$AGE_AT_SEQ_REPORT)
  if (multiply) {
    genieClinData$age_days <- genieClinData$age_days * 365
  }
  
  k = is.na(genieClinData$age_days)
  t = as.data.frame.matrix(table(genieClinData$CENTER,k))
  kable(data.frame("Percent.Unknown"=(t[,"TRUE"]/rowSums(t))*100),digits=2)
  
  k = !is.na(genieClinData$age_days)
  plot(ggplot(genieClinData[k,], aes(x = (age_days/365), group = CENTER)) +
         geom_histogram(aes(y = (..count..)/width/tapply(..count..,..group..,sum)[..group..]),
                        breaks = c(0,seq(19,89,2),90,108),
                        closed = "left") +
         facet_wrap(~CENTER,ncol = 4) +
         ylab("Density") +
         xlab("Age") +
         ggtitle("Distribution of age across centers"))
}

get_release_synid <- function(release_folder_fileview_synid, release) {
  release_folder = synTableQuery(
    sprintf("select id from %s where name = '%s'",
            release_folder_fileview_synid, release)
  )
  release_folderdf = release_folder$asDataFrame()
  if (nrow(release_folderdf) == 0) {
    stop(sprintf("Could not find release: %s", release))
  }
  release_folderdf$id
}

get_latest_public_release <- function(release) {
  major_release = unlist(strsplit(release, "[.]"))[1]
  public_major_release = as.numeric(major_release) - 1
  public_rel = synTableQuery(paste0(
    "select * from syn22233011 where ",
    sprintf("name like 'Release %s.", public_major_release),
    "%-public'"
  ))
  public_reldf = public_rel$asDataFrame()
  if (nrow(public_reldf) == 0) {
    stop(sprintf("Could not find public release for: %s", public_major_release))
  }
  public_reldf$id
}
```

```{r downloads, echo=FALSE, message=FALSE, results = 'hide'}
database_synid_mapping = synTableQuery(sprintf('select * from %s',
                                               database_synid_mappingid))
database_synid_mappingdf = as.data.frame(database_synid_mapping)
release_folder_fileview_synid = database_synid_mappingdf$Id[
  database_synid_mappingdf$Database == "releaseFolder"
]
release_synid = get_release_synid(release_folder_fileview_synid, release)
releaseFiles = as.list(synGetChildren(release_synid))
this_samples <- getFileDf("data_clinical.txt", releaseFiles)
if (is.null(this_samples)) {
  this_samples <- getFileDf("data_clinical_sample.txt", releaseFiles)
  this_patient <- getFileDf("data_clinical_patient.txt", releaseFiles)
  this_patient$CENTER <- createCenterColumn(this_patient)
  this_samples$CENTER <- createCenterColumn(this_samples)
} else {
  this_patient <- this_samples
  this_patient <- this_patient[!duplicated(this_patient$PATIENT_ID),]
}
this_bed <- getFileDf("genomic_information.txt", releaseFiles)
if (is.null(this_bed)) {
  this_bed <- getFileDf("genie_combined.bed", releaseFiles)
}
this_assays = as.character(unique(this_samples$SEQ_ASSAY_ID))
this_mut <- getFileDf("data_mutations_extended.txt", releaseFiles)
assay_infodf = getFileDf("assay_information.txt", releaseFiles)
black_list_variants <- synTableQuery(
  "select * from syn18459663 where filter_variant is true",
  includeRowIdAndRowVersion = F
)
black_list_variantsdf = black_list_variants$asDataFrame()
# this_cna <- getFileDf("data_CNA.txt", releaseFiles)
#this_fus <- getFileDf("data_fusions.txt", releaseFiles)

# Get most recent public release clinical file
public_release_synid = get_latest_public_release(release)
public_release_files = as.list(synGetChildren(public_release_synid))
public_sampledf <- getFileDf("data_clinical_sample.txt", public_release_files)

public_sampledf$CENTER = sapply(strsplit(public_sampledf$SEQ_ASSAY_ID, "-"),
                                function(x) x[1])
```


## Sample and Variant Count per center
Please confirm that the the number of samples and variants in this release is what you expect. The "New Sample" column shows the number of new samples submitted since the last public release. A gentle reminder for sites that it is GENIE policy to submit at least 500 samples per year.  Please contact AACR if you cannot do this.

```{r sampleTable}
sampleCounts = table(this_samples$CENTER)
samplesPerReleaseDf = as.data.frame(sampleCounts)
colnames(samplesPerReleaseDf) = c("Center", "Samples")
variant_counts = table(this_mut$Center)
variant_countsdf = as.data.frame(variant_counts)
colnames(variant_countsdf) = c("Center", "Variants")
release_infodf = merge.data.frame(samplesPerReleaseDf, variant_countsdf, by="Center", all=T)
release_infodf[is.na(release_infodf)] = 0
samplesPerReleaseDf = rbind(release_infodf,
                            data.frame("Center" = "Total",
                                       "Samples" = sum(sampleCounts),
                                       "Variants" = sum(variant_counts)))

# Get sample difference
public_center_sample_count = table(public_sampledf$CENTER)
center_differences = c()
for (center in names(sampleCounts)) {
  center_current =  sampleCounts[center]
  public_center_current = public_center_sample_count[center]
  if (is.na(public_center_current)) {
    public_center_current = 0
  }
  if (is.na( center_current)) {
    center_current = 0
  }
  release_difference = center_current - public_center_current
  center_differences[center] = release_difference
}
center_differences = c(center_differences, sum(center_differences))
samplesPerReleaseDf["New Samples"] = center_differences
kable(samplesPerReleaseDf, row.names = F,
      caption = "Number of samples and variants per center")
```

---

## GENIE Retraction Policy

```{r determine_retraction, echo=F, include=F}
sampledb_synid = database_synid_mappingdf$Id[
  database_synid_mappingdf$Database == "sample"
]
sample_retract_synid = database_synid_mappingdf$Id[
  database_synid_mappingdf$Database == "sampleRetraction"
]
patient_retract_synid = database_synid_mappingdf$Id[
  database_synid_mappingdf$Database == "patientRetraction"
]

sample_table = synTableQuery(sprintf("SELECT SAMPLE_ID FROM %s",
                                     sampledb_synid))

db_samplesdf = sample_table$asDataFrame()

# check for samples in public release that are no longer in
# consortium release
exist_idx = public_sampledf$SAMPLE_ID %in% this_samples$SAMPLE_ID
in_db_samples_idx = public_sampledf$SAMPLE_ID %in% db_samplesdf$SAMPLE_ID

# Get all possibly retracted
# The reason possibly because samples could have been renamed
possible_retracted = public_sampledf[!exist_idx & !in_db_samples_idx,
                                     c("SAMPLE_ID", "PATIENT_ID", "CENTER")]

# Determine if sample is explicitly or implicitly retracted
# assume most samples are implicitly retracted
if (nrow(possible_retracted) > 0) {
  possible_retracted$RETRACTION = "implicit"
  # Get explicitly retracted
  retracted_patient = synTableQuery(
    sprintf("select geniePatientId from %s", patient_retract_synid)
  )
  retracted_patientdf = retracted_patient$asDataFrame()
  retracted_sample = synTableQuery(
    sprintf("select genieSampleId from %s", sample_retract_synid)
  )
  retracted_sampledf = retracted_sample$asDataFrame()

  retracted_patients_idx = possible_retracted$PATIENT_ID %in%
    retracted_patientdf$geniePatientId
  retracted_samples_idx = possible_retracted$SAMPLE_ID %in%
    retracted_sampledf$genieSampleId

  possible_retracted$RETRACTION[
      retracted_patients_idx & retracted_samples_idx
  ] = 'explicit'

}
write.csv(possible_retracted, "samples_to_retract.csv", row.names=F, quote=F)
ent = synStore(File("samples_to_retract.csv", parent=release_synid))
unlink("samples_to_retract.csv")
```

This table below lists the number of samples explicitly or implicitly retracted by centers.


```{r}
if (nrow(possible_retracted) > 0) {
  kable(table(possible_retracted$CENTER, possible_retracted$RETRACTION))
} else {
  kable(possible_retracted)
}
```

These `r paste0("[sample/patient IDs](https://www.synapse.org/#!Synapse:", ent$properties$id, "){target='_blank'}")`
have been marked for retraction from GENIE and have been removed from the GENIE database.
However, removal from public release files occurs according to the following fixed schedule.
Please apprise your patients of this schedule so that they are aware of the timeline for retraction of their data.
If you see samples that should not be retracted, please upload a fix to your data or let Tom Yu from Sage know immediately.


For patient retractions submitted between these months, a new public release will be generated that removes the affected records. The new release will be issued no later than April or October, respectively:

* January-March
* July-September

For patient retractions submitted between these months, the records will be removed from the next regularly-scheduled public release in July or January, respectively:

* April-June
* October-December


---

## Flagged Mutations
This is a count of how many flagged mutations a center has. Most of these variants are potential
artifacts flagged by manual review of cBioPortal. Please inform Sage Bionetworks about:

* Suggestions for variants that should be part of this list
* Any variant shouldn't be part of this list

```{r blacklist}
blacklist_variants = paste(black_list_variantsdf$Hugo_Symbol,
                           black_list_variantsdf$HGVSp_Short)
subset_mut = this_mut[this_mut$Hugo_Symbol %in% black_list_variantsdf$Hugo_Symbol, ]
subset_mut$blacklist = paste(subset_mut$Hugo_Symbol,
                             subset_mut$HGVSp_Short)
subset_mut = subset_mut[subset_mut$blacklist %in% blacklist_variants,]
kable(table(subset_mut$blacklist, subset_mut$Center),
      caption = "Blacklist variant count")
```


---

## Distribution of Clinical Attributes
Please use the below distributions to access the validity of your clinical data.  There will be some tips for what to look for in each section.

### Race
Some european sites like GRCC, CRUK, and NKI do not collect race information from their patients.  If your institution does not either, you should see empty barplots.

```{r race}
#Center X Race
par(mar = c(10,3,3,1))
plotCenterXRace(this_patient)
```

### Ethnicity
Some european sites like GRCC, CRUK, and NKI do not collect ethnicity information from their patients.  If your institution does not either, you should see empty barplots.

```{r ethnicity}
#Center X Ethnicity
par(mar = c(10,3,3,1))
plotCenterXEthnicity(this_patient)
```

### Sex
CRUK submits samples from breast cancer patients, so their samples are all female.

```{r sex}
#Center X Sex
par(mar = c(10,3,3,1))
plotCenterXSex(this_patient)
```

### Age
CHOP submits mainly pediatric cases, so their distribution is different from the rest.


```{r age}
#Center X Age
par(mar = c(10,3,3,1))
plotCenterXAge(this_samples)
```


```{r seqyear, include=F, echo=F}
check_seq_year = "SEQ_YEAR" %in% colnames(this_samples)
```

<!-- `r if(check_seq_year) {"### Sequencing year\nThis is to show the SEQ_YEAR distribution."}` -->

<!-- ```{r, echo=F} -->
<!-- if (check_seq_year) { -->
<!--   kable(table(this_samples$SEQ_YEAR, this_samples$CENTER)) -->
<!-- } -->
<!-- ``` -->


### Cancer Type (Null)
This will show NULL or UNKNOWN cancer types.

```{r cancertype}
unknown_cancer_type = this_samples$CANCER_TYPE %in% c("UNKNOWN", '')
null_cancer_type = is.na(this_samples$CANCER_TYPE)

na_cancer_type_subset = this_samples[unknown_cancer_type | null_cancer_type, ]
kable(table(na_cancer_type_subset$CANCER_TYPE, na_cancer_type_subset$CENTER))
```

---

## Missing Variant Counts
These are the sites with missing `t_depth`, `t_alt_count` and `t_ref_count` values.
```{r variantcounts, echo=F}
missing_t_depth_idx = is.na(this_mut$t_depth)
missing_t_ref_count_idx = is.na(this_mut$t_ref_count)
missing_t_alt_count_idx =  is.na(this_mut$t_alt_count)

missing_t_depth = table(this_mut$Center[missing_t_depth_idx])
missing_t_ref_count = table(this_mut$Center[missing_t_ref_count_idx])
missing_t_alt_count = table(this_mut$Center[missing_t_alt_count_idx])
centers = unique(c(names(missing_t_depth),
                   names(missing_t_ref_count),
                   names(missing_t_alt_count)))
missing_counts = matrix(data=NA, nrow=length(centers), ncol=3,
                        dimnames = list(centers,
                                        c("t_depth", "t_alt_count",
                                          "t_ref_count")))


missing_counts[names(missing_t_depth), 't_depth'] = missing_t_depth
missing_counts[names(missing_t_ref_count), 't_ref_count'] = missing_t_ref_count
missing_counts[names(missing_t_alt_count), 't_alt_count'] = missing_t_alt_count
missing_counts[is.na(missing_counts)] = 0
kable(missing_counts)
```

---

## Top 5 most frequently mutated genes per pipeline

To assist with discovering artifacts in a center's data, this will summarize the top 5 most frequently mutated genes per pipline for all non-synonymous mutations.  All mutations that have `Variant_Classifications` of "Silent", "Intron", "3'UTR", "3'Flank", "5'UTR", "IGR" and "5'Flank" are filtered out with the exception of TERT promoters. One of the easiest questions to answer is:

**Has the frequently mutated gene list changed significantly? Is TP53 still #1?**

### All pipelines

Top 5 most frequently mutated genes per pipeline for all pipelines.

```{r, include=F}
# Filter maf file to only contain non synonymous variants.
# Follow same strategy here:
# https://github.com/cBioPortal/cbioportal/blob/v3.3.4/core/src/main/java/org/mskcc/cbio/portal/scripts/MutationFilter.java#L86
filter_maf <- function(mafdf) {
  filter_classifications = c("Silent", "Intron", "3'UTR",
                             "3'Flank", "5'UTR", "IGR")
  non_coding_mutations = mafdf$Variant_Classification %in% filter_classifications
  # Remove non coding
  mafdf <- mafdf[!non_coding_mutations, ]
  flank_classification = mafdf$Variant_Classification == "5'Flank"
  tert_mutations = mafdf$Hugo_Symbol == "TERT"
  # Remove 5'Flank unless it is TERT
  mafdf[!flank_classification | tert_mutations, ]
}
filtered_mafdf <- filter_maf(this_mut)

```


```{r top_5_mutated, echo=FALSE}
mergeddf = merge.data.frame(filtered_mafdf[,c("Tumor_Sample_Barcode", "Hugo_Symbol")],
                            this_samples[,c("SAMPLE_ID", "SEQ_ASSAY_ID")],
                            by.x = "Tumor_Sample_Barcode",
                            by.y = "SAMPLE_ID")
# TODO: can remove NA is fixed
na_pipeline = assay_infodf$SEQ_PIPELINE_ID == ""
assay_infodf$SEQ_PIPELINE_ID[na_pipeline] = assay_infodf$SEQ_ASSAY_ID[na_pipeline]

# Merge in assay information to group by seq pipeline id
mergeddf = merge.data.frame(mergeddf,
                            assay_infodf[,c("SEQ_ASSAY_ID", "SEQ_PIPELINE_ID")],
                            by = "SEQ_ASSAY_ID")

mutated_genes = table(mergeddf$Hugo_Symbol, mergeddf$SEQ_PIPELINE_ID)
# Top 5 mutated genes per panel
top_5_mutated_genes = apply(mutated_genes, 2, function(x) {
  list(sort(x, decreasing = T)[1:5])
})
top_5_mutated_genes_string = apply(mutated_genes, 2, function(x) {
  top_5 = sort(x, decreasing = T)[1:5]
  paste(names(top_5), top_5, sep = ": ")
})
transposed_matrix = t(top_5_mutated_genes_string)
final_matrix = cbind(transposed_matrix, table(mergeddf$SEQ_PIPELINE_ID)[row.names(transposed_matrix)])
colnames(final_matrix) = c(1, 2, 3, 4, 5, "Total Variants")
kable(final_matrix,
      caption = "Distribution of top 5 most frequently mutated genes per SEQ_PIPELINE_ID")

```


### Panels Covering TP53

These are all the pipelines that cover TP53 that don't have TP53 as the top mutated genes.  If your pipeline is shown in the table below, it is _possible_ that you have artifacts in your data.  **Please review and reupload if your data is incorrect**  The release notes will capture if sites have confirmed that the variants shown in this table has no artifacts.


```{r highlight_panels, echo=FALSE}
this_bed = merge.data.frame(this_bed,
                            assay_infodf[,c("SEQ_ASSAY_ID", "SEQ_PIPELINE_ID")],
                            by = "SEQ_ASSAY_ID")
if (!is.null(this_bed)) {
  panels_covering_tp53 = unique(this_bed$SEQ_PIPELINE_ID[this_bed$Hugo_Symbol == "TP53"])
  # Exclude panels if TP53 is top mutated
  tp53_not_top = sapply(names(top_5_mutated_genes), function(seq_assay) {
    if (names(top_5_mutated_genes[[seq_assay]][[1]][1]) != "TP53") {
      return(seq_assay)
    }
  })
  relevant_panels = mutated_genes[, colnames(mutated_genes) %in% panels_covering_tp53]
  relevant_panels = relevant_panels[, colnames(relevant_panels) %in% unlist(tp53_not_top)]
  top_5_mutated_genes_string = apply(relevant_panels, 2, function(x) {
    top_5 = sort(x, decreasing = T)[1:5]
    paste(names(top_5), top_5, sep = ": ")
  })
  transposed_matrix = t(top_5_mutated_genes_string)
  final_matrix = cbind(transposed_matrix, table(mergeddf$SEQ_PIPELINE_ID)[row.names(transposed_matrix)])
  colnames(final_matrix) = c(1, 2, 3, 4, 5, "Total Variants")
  kable(final_matrix,
        caption = "Distribution of top 5 most frequently mutated genes per SEQ_PIPELINE_ID")
}
```

---

## Assay information vs genomic information discrepancies

During processing, each panel's bed file undergoes gene symbol harmonization and is used to generate a gene panel file used in cBioPortal.
A user of the GENIE data pointed out that the expected gene count numbers in the data guide did not match up to the number of genes in the gene panel files made from each center's bed files.  The table below was created to assist with resolving these issues.

**Here are some action items required if your panel appears in the table**. The assay_information.yaml file is a file that I assisted all the centers to create, and can be found in each center’s input directory.

* `num_genes_remapped`:  number of unique genes a panel has after submitted genes are remapped
* `num_genes_submitted`: number of unique genes found in site's submitted BED file prior to remapping
* `num_genes_expected`: size of panel as defined in site's submitted assay_information.yaml file

1. If the `num_genes_expected` is NA, this means your panel is either missing from your assay_information.yaml, or the file is in an invalid format and cannot be processed.  Please provide a fix.
2. If the `num_genes_remapped` does not match `num_genes_expected`, please make sure one of the two values is correct.
   a. If `num_genes_expected` is incorrect, please update the value in your `assay_information.yaml` file.
   b. If `num_genes_remapped` is incorrect, please update your coordinates or gene symbols in the bed file.  Please view the bed submission guidelines to learn more about the remapping.
3. If there is a huge difference between your `num_genes_submitted` and `num_genes_remapped`, there is a high chance that you are submitting "invalid" gene symbols.  (ie.  PDGFRA1 is not equivalent to PDGFRA and PDGFRA1 is an invalid symbol name)


```{r genepanel_diff, echo=F}
if (!is.null(assay_infodf) & !is.null(this_bed)) {
  gene_panel_bed = this_bed[this_bed$Feature_Type == "exon" & this_bed$includeInPanel == "True" & this_bed$Hugo_Symbol != "", ]
  # Get count of symbols per panel
  symbol_count_per_panel = table(gene_panel_bed$Hugo_Symbol, gene_panel_bed$SEQ_ASSAY_ID)
  # Get whether or not a panel contains a certain symbol
  symbol_bool_per_panel = symbol_count_per_panel > 0
  # Sum of the columns gets number of unique genes per panel
  number_of_genes = data.frame(colSums(symbol_bool_per_panel))

  submitted_count = table(gene_panel_bed$ID, gene_panel_bed$SEQ_ASSAY_ID)
  submitted_bool_per_panel = submitted_count > 0
  num_submitted_genes = colSums(submitted_bool_per_panel)
  colnames(number_of_genes) = "num_genes_remapped"
  number_of_genes$num_genes_submitted = NA
  number_of_genes$num_expected_genes = NA
  number_of_genes[names(num_submitted_genes), "num_genes_submitted"] = num_submitted_genes
  number_of_genes[assay_infodf$SEQ_ASSAY_ID, "num_expected_genes"] = assay_infodf$number_of_genes

  different_from_expected = number_of_genes[c(which(number_of_genes$num_genes_remapped != number_of_genes$num_expected_genes),
                                              which(is.na(number_of_genes$num_expected_genes))),]
  kable(different_from_expected,
        caption = "Number of submitted vs expected genes in a bed file")
}
```

---

## Gene Panel Overlaps
This section will show the number of genes that overlap between the myeloid, small and large GENIE panels.

```{r bed_process, include=F}
if (!is.null(this_bed)) {
  this_bed <- this_bed[this_bed$Feature_Type == "exon",]
  #Make it so that I use include in panel
  if (!is.null(this_bed$includeInPanel)) {
    this_bed <- this_bed[this_bed$includeInPanel == "True",]
  }
  noneExistentAssays = this_assays[!this_assays %in% this_bed$SEQ_ASSAY_ID]
  if (length(noneExistentAssays) > 0) {
    print(paste("These assays do not have bed files associated with them: ", 
                paste(noneExistentAssays, collapse = ", ")))
  }
  this_assays = this_assays[this_assays %in% this_bed$SEQ_ASSAY_ID]
  myeloid_panels = c("VICC-01-MYELOID","UHN-54-V1","UCHI-ONCOHEME55-V1","CHOP-HEMEP","MSK-IMPACT-HEME-399")
  myeloid = this_assays[this_assays %in% myeloid_panels]

  normal = this_assays[!this_assays %in% myeloid_panels]
  seq_pipeline_ids = unique(
    this_bed$SEQ_PIPELINE_ID[this_bed$SEQ_ASSAY_ID %in% normal]
  )
  smallPanels = c()
  largePanels = c()
  for (panel in seq_pipeline_ids) {
    panelDf = this_bed[this_bed$SEQ_PIPELINE_ID == panel,]
    if (length(table(panelDf$Hugo_Symbol)) < 100) {
      smallPanels = c(smallPanels, panel)
      # Don't add to panel if more than 1500 genes
    } else if (length(table(panelDf$Hugo_Symbol)) < 1500) {
      largePanels = c(largePanels, panel)
    }
  }
} else {
  largePanels = c()
  smallPanels = c()
  myeloid = c()
}
```

### Meyloid Gene Panels

```{r myeloid_panel_upset}
if (length(myeloid) > 1) {
  plotPanelOverlap(this_bed, myeloid)
}

```

### Small (<100) Gene panels

```{r small_panel_upset, fig.height=12}
if (length(smallPanels) > 1) {
  plotPanelOverlap(this_bed, smallPanels)
}
```

### Large ($\geq$ 100) Gene panels

```{r large_panel_upset, fig.height=12}
if (length(largePanels) > 1) {
  plotPanelOverlap(this_bed, largePanels)
}
```

---

## Possible Non-center Related Data Issues

This section includes QC issues that are mostly related to the Sage Bionetworks pipeline, Genome Nexus or _maybe_ center related issues.

### Duplicated Variants

```{r, include=F, echo=F}
variant <- paste0(this_mut$Tumor_Sample_Barcode, "_",
                  this_mut$Chromosome, ":",
                  this_mut$Start_Position, "_",
                  this_mut$Reference_Allele, "/",
                  this_mut$Tumor_Seq_Allele2)
duplicated_idx = duplicated(variant)

write.csv(this_mut[duplicated_idx,
                   c("Chromosome", "Start_Position", "Reference_Allele",
                     "Tumor_Seq_Allele2", "Tumor_Sample_Barcode")],
          "duplicated_variants.csv",
          row.names=F, quote=F)
duplicate_v_ent = synStore(File("duplicated_variants.csv", parent=release_synid))
unlink("duplicated_variants.csv")
```

There are `r sum(duplicated_idx)` duplicated variant(s). Ignore the rest if the number is 0. These `r paste0('[duplicated variants](https://www.synapse.org/#!Synapse:', duplicate_v_ent$properties$id, "){target='_blank'}")` are potentially caused by the annotation pipeline as no duplicated variants are allowed in each maf or vcf file.


### Non-somatic Variants

```{r nonsomatic, echo=F, include=F}
non_somatic <- this_mut[this_mut$Reference_Allele==this_mut$Tumor_Seq_Allele2 &
                          this_mut$Reference_Allele==this_mut$Tumor_Seq_Allele1,]
write.csv(non_somatic[, c("Hugo_Symbol", "Chromosome", "Reference_Allele",
                          "Tumor_Seq_Allele1", "Tumor_Seq_Allele2",
                          "Tumor_Sample_Barcode")],
          "non_somatic.csv",
          row.names=F, quote=F)
non_somatic_ent = synStore(File("non_somatic.csv", parent=release_synid))
unlink("non_somatic.csv")
```

There are `r nrow(non_somatic)` non somatic variant(s). Ignore the rest if the number is 0. These `r paste0('[variants](https://www.synapse.org/#!Synapse:', non_somatic_ent$properties$id, "){target='_blank'}")` should be removed from the data.

### SNV labelled as DNP

```{r is_dnp, echo=F, include=F}
is_dnp <- nchar(this_mut$Reference_Allele) == nchar(this_mut$Tumor_Seq_Allele2) &
          nchar(this_mut$Reference_Allele)==2 & this_mut$Variant_Type == "DNP"
dnp <- this_mut[is_dnp, ]
not_dnp <- dnp[
  substr(dnp$Reference_Allele, 1, 1) == substr(dnp$Tumor_Seq_Allele2, 1, 1) |
  substr(dnp$Reference_Allele, 1, 2) == substr(dnp$Tumor_Seq_Allele2, 1, 2),
]
write.csv(not_dnp[,c("Hugo_Symbol", "Chromosome", "Reference_Allele",
                     "Tumor_Seq_Allele2", "Tumor_Sample_Barcode",
                     "Variant_Type")],
          "snv_as_dnp.csv",
          row.names=F, quote=F)
dnp_ent = synStore(File("snv_as_dnp.csv", parent=release_synid))
unlink("snv_as_dnp.csv")
```

There are `r nrow(not_dnp)` SNV(s) labelled as DNP(s). Ignore the rest if the number is 0. These are `r paste0('[variants](https://www.synapse.org/#!Synapse:', dnp_ent$properties$id, "){target='_blank'}")` that have variant type DNP that should be SNV.

### SNV labelled as ONP

```{r is_onp, echo=F, include=F}
is_onp <- nchar(this_mut$Reference_Allele) == nchar(this_mut$Tumor_Seq_Allele2) &
          nchar(this_mut$Reference_Allele) == 3 & this_mut$Variant_Type == "ONP"
onp <- this_mut[is_onp, ]
not_onp <- onp[
  substr(onp$Reference_Allele, 1, 1) == substr(onp$Tumor_Seq_Allele2, 1, 1) |
  substr(onp$Reference_Allele, 1, 2) == substr(onp$Tumor_Seq_Allele2, 1, 2),
]

write.csv(not_onp[, c("Hugo_Symbol", "Chromosome", "Reference_Allele",
                      "Tumor_Seq_Allele2", "Tumor_Sample_Barcode",
                      "Variant_Type")],
          "snv_as_onp.csv", row.names=F, quote=F)
onp_ent = synStore(File("snv_as_onp.csv", parent=release_synid))
unlink("snv_as_onp.csv")

```

There are `r nrow(not_onp)` SNV(s) labelled as ONP(s). Ignore the rest if the number is 0. These are `r paste0('[variants](https://www.synapse.org/#!Synapse:', onp_ent$properties$id, "){target='_blank'}")` that have variant type ONP that should be SNV.
